

drop function if exists random_author;
CREATE FUNCTION random_author(x int) returns table (id int) LANGUAGE SQL AS
$$
	SELECT round(random()*(SELECT max(id)-1 from authors)+1)::int
$$;


drop function if exists random_cat;
CREATE FUNCTION random_cat(x int) returns table (id int) LANGUAGE SQL AS
$$
	SELECT round(random()*(SELECT max(id)-1 from book_categories)+1)::int
$$;

drop function if exists random_stock;
CREATE FUNCTION random_stock(x int) returns table (id int) LANGUAGE SQL AS
$$
	SELECT round(random()*(SELECT max(id)-1 from stocks)+1)::int
$$;

drop function if exists random_copy;
CREATE FUNCTION random_copy(x int) returns table (id int) LANGUAGE SQL AS
$$
	SELECT round(random()*(SELECT max(id)-1 from copies) + 1)::int
$$;

drop function if exists random_reader;
CREATE FUNCTION random_reader(x int) returns table (id int) LANGUAGE SQL AS
$$
	SELECT round(random()*(SELECT max(id)-1 from readers) + 1)::int
$$;

create table tmp_readers
(
    first_name varchar,
    last_name varchar
);

insert into tmp_readers (first_name, last_name)
values
	('James', 'Butt' ),
	('Josephine', 'Darakjy' ),
	('Art', 'Venere' ),
	('Lenna', 'Paprocki' ),
	('Donette', 'Foller' ),
	('Simona', 'Morasca' ),
	('Mitsue', 'Tollner' ),
	('Leota', 'Dilliard' ),
	('Sage', 'Wieser' ),
	('Kris', 'Marrier' ),
	('Minna', 'Amigon' ),
	('Abel', 'Maclead' ),
	('Kiley', 'Caldarera' ),
	('Graciela', 'Ruta' ),
	('Cammy', 'Albares' ),
	('Mattie', 'Poquette' ),
	('Meaghan', 'Garufi' ),
	('Gladys', 'Rim' ),
	('Yuki', 'Whobrey' ),
	('Fletcher', 'Flosi' ),
	('Bette', 'Nicka' ),
	('Veronika', 'Inouye' ),
	('Willard', 'Kolmetz' ),
	('Maryann', 'Royster' ),
	('Alisha', 'Slusarski' ),
	('Allene', 'Iturbide' ),
	('Chanel', 'Caudy' ),
	('Ezekiel', 'Chui' ),
	('Willow', 'Kusko' ),
	('Bernardo', 'Figeroa' ),
	('Ammie', 'Corrio' ),
	('Francine', 'Vocelka' ),
	('Ernie', 'Stenseth' ),
	('Albina', 'Glick' ),
	('Alishia', 'Sergi' ),
	('Solange', 'Shinko' ),
	('Jose', 'Stockham' ),
	('Rozella', 'Ostrosky' ),
	('Valentine', 'Gillian' ),
	('Kati', 'Rulapaugh' ),
	('Youlanda', 'Schemmer' ),
	('Dyan', 'Oldroyd' );
	


insert into authors (first_name, last_name)
values
	('Bill', 'McKibben'),
	('Harold', 'Bloom'),
	('Nikki', 'Giovanni'),
	('Paul', 'Auster'),
	('Peter', 'Straub'),
	('Phillip', 'Lopate'),
	('Ann', 'Charters'),
	('Walter', 'Mosley'),
	('David', 'Remnick'),
	('Lorrie', 'Moore'),
	('Cristina', 'Garcia'),
	('Ilan', 'Stavans'),
	('Michael', 'Chabon'),
	('Edwidge', 'Danticat'),
	('Adam', 'Gopnik'),
	('Honor', 'Moore'),
	('Larry', 'McMurtry'),
	('Barbara', 'Kingsolver'),
	('Caroline', 'Kennedy'),
	('Richard', 'Wright'),
	('Carmela', 'Ciuraru'),
	('Tony', 'Hillerman'),
	('Sue', 'Miller'),
	('Jay', 'Atkinson'),
	('Laura', 'Furman'),
	('Barbara', 'Smith'),
	('Mark', 'Twain'),
	('Billy', 'Collins'),
	('Thomas', 'Wolfe'),
	('Diane', 'Fanning'),
	('Salman', 'Rushdie'),
	('Oscar', 'Wilde'),
	('Maeve', 'Binchy'),
	('Virginia', 'Woolf'),
	('Wally', 'Lamb'),
	('Bill', 'McKibben'),
	('Harold', 'Bloom'),
	('Nikki', 'Giovanni'),
	('Paul', 'Auster'),
	('Peter', 'Straub'),
	('Phillip', 'Lopate');

insert into authors (first_name, last_name)
select 'auth_name'||i, 'auth_surname'||i
from generate_series(1, 1500) as seq(i);

insert into books (title)
values
	('The Caine Prize for African Writing 2010: 11th Annual Collection'),
	('African Folktales'),
	('Unchained Voices: An Anthology of Black Authors in the English-Speaking World of the Eighteenth Century'),
	('Women Writing Africa: West Africa and the Sahel'),
	('10 Years of the Caine Prize for African Writing: Plus Coetzee, Gordimer, Achebe, Okri'),
	('Introduction to African Oral Literature and Performance'),
	('Oral Epics from Africa'),
	('Land Apart: A South African Reader'),
	('Women Writing Africa: The Eastern Region'),
	('Nobody Ever Said AIDS: Poems and Stories from Southern Africa'),
	('Step into a World: A Global Anthology of the New Black Literature'),
	('An Anthology of Interracial Literature: Black-White Contacts in the Old World and the New'),
	('The Caine Prize 2009: The Caine Prize for African Writing 10th Annual Collection'),
	('Traditions in World Literature: Literature of Africa, Softcover Student Edition'),
	('Love Child'),
	('Seventh Street Alchemy 2004: A Selection of Works from the Caine Prize for African Writing'),
	('Women Writing Africa: The Southern Region: Volume 1'),
	('The Rienner Anthology of African Literature'),
	('Oral and Written Expressions of African Cultures'),
	('Jambula Tree and other stories: The Caine Prize for African Writing 8th Annual Collection'),
	('Up the Down Escalator'),
	('Basali!: Stories by and about Women in Lesotho'),
	('How God Fix Jonah'),
	('Glass Jars among Trees'),
	('Running Towards Us: New Writing from South Africa'),
	('Of Suffocated Hearts And Tortured Souls'),
	('An Anthology of Interracial Literature: Black-White Contacts in the Old World and the New'),
	('Among the Blacks'),
	('100 Best-Loved Poems'),
	('The Norton Anthology of American Literature, Shorter Seventh Edition, One-Volume Paperback'),
	('The Best American Poetry 2009'),
	('The Oxford Book of American Short Stories'),
	('The Best American Essays 2009'),
	('The Norton Anthology of American Literature, Package 2: Volumes C, D, and E'),
	('Early African American Classics (Barnes &amp; Noble Classics Series)'),
	('African-American Poetry: An Anthology, 1773-1930'),
	('The Norton Anthology of Poetry, Shorter 5th Edition'),
	('The Best American Poetry 2010'),
	('Classic Slave Narratives'),
	('The Best American Nonrequired Reading 2009'),
	('In Fact: The Best of Creative Nonfiction'),
	('The Best American Essays of the Century'),
	('The Best Loved Poems of the American People'),
	('The Norton Anthology of American Literature: Volume A: Beginnings to 1820'),
	('The Norton Anthology of Poetry'),
	('The Norton Anthology of African American Literature, Vol. 2'),
	('Poems, Poets, Poetry: An Introduction and Anthology'),
	('The Poets Laureate Anthology'),
	('The Portable Beat Reader'),
	('The Best American Short Plays 2008-2009'),
	('The Gift of Love'),
	('One Hundred and One Famous Poems (Barnes &amp; Noble Library of Essential Reading)'),
	('The Vintage Book of Contemporary American Poetry'),
	('Literature: A Pocket Anthology'),
	('American Earth: Environmental Writing Since Thoreau'),
	('Best Poems of the English Language: From Chaucer Through Robert Frost'),
	('Humor Me: An Anthology of Funny Contemporary Writing (Plus Some Great Old Stuff Too)'),
	('Coming of Age in America: A Multicultural Anthology'),
	('Three African-American Classics: Up from Slavery, The Souls of Black Folk and Narrative of the Life of Frederick Douglass'),
	('100 Best African American Poems with CD'),
	('Six American Poets: An Anthology'),
	('Norton Anthology of Literature by Women: The Traditions in English'),
	('The Voice That Is Great within Us: American Poetry of the Twentieth Century'),
	('Poems That Touch the Heart'),
	('Listening For God Rdr Vol 4'),
	('The American Tradition in Literature (concise) book alone'),
	('Approaching Literature: Writing, Reading, Thinking'),
	('The Norton Anthology of American Literature: Volume C: 1865-1914'),
	('American Fantastic Tales Boxed Set'),
	('Unsettling America: An Anthology of Contemporary Multicultural Poetry'),
	('Listening For God Reader, Vol 1'),
	('Concise Anthology of American Literature'),
	('The Heath Anthology of American Literature: Contemporary Period (1945 To The Present), Volume E'),
	('The Portable Harlem Renaissance Reader'),
	('American Short Stories'),
	('Great Love Poems'),
	('The Harper American Literature, Single Volume Edition'),
	('The Latino Reader: An American Literary Tradition from 1542 to the Present'),
	('Black Nature'),
	('Anthology of American Literature Volume II'),
	('Best Remembered Poems'),
	('Nine Plays of the Modern Theater'),
	('The Norton Anthology of Literature by Women: The Traditions in English, Vol. 2'),
	('Writing New York: A Literary Anthology'),
	('The Best American Essays 2009'),
	('The Hudson River Valley Reader'),
	('The Best American Poetry 2009'),
	('Sudden Fiction Latino: Short-Short Stories from the United States and Latin America'),
	('I Am the Darker Brother: An Anthology of Modern Poems by African Americans'),
	('Classic American Autobiographies'),
	('Mental Floss: Scatterbrained'),
	('The Portable Sixties Reader'),
	('Modern American Memoirs'),
	('Best American Spiritual Writing 2007'),
	('The Norton Anthology of American Literature: Volume D: 1914-1945'),
	('Making Literature Matter: An Anthology for Readers and Writers'),
	('Luis Valdez - Early Works: Actos, Bernabe and Pensamiento Serpentino'),
	('In Our Own Words: Student Writers at Work'),
	('Touch'),
	('The American Tradition in Literature, Volume 1(book alone)'),
	('The Four Seasons: Poems'),
	('The American Stage: Writing on Theater from Washington Irving to Tony Kushner'),
	('Bum Rush the Page: A Def Poetry Jam'),
	('The Outlaw Bible of American Literature'),
	('Mother California: A Story of Redemption Behind Bars');

insert into books(title)
select 'title'||i
from generate_series(1, 25000) as seq(i);


create table tmp_book_categories
(
	cat_name varchar
);

insert into tmp_book_categories (cat_name)
values
	('Christian Fiction'), 
	('Drama'), 
	('Essays'), 
	('Literature Classics'), 
	('Fiction Subjects'), 
	('Comic Books'), 
	('Historical Fiction'), 
	('Horror'), 
	('Letters'), 
	('Mystery and Crime'), 
	('Poetry'), 
	('Romance'), 
	('Science Fiction'), 
	('Short Stories'), 
	('Teen Fiction'), 
	('Thrillers'), 
	('Military Fiction'), 
	('Westerns'), 
	('Alternative Comics'), 
	('Biographical'), 
	('DC Comics'), 
	('Horror'), 
	('International Graphic Novels'), 
	('Manga'), 
	('Marvel Comics'), 
	('Newspaper'), 
	('Ghost Stories'), 
	('Gothic Horror'), 
	('Psychological Horror'), 
	('Supernatural Horror'), 
	('Zombies'), 
	('Crime Fiction'), 
	('Detective Fiction'), 
	('Multicultural Detectives'), 
	('Police Stories'), 
	('Women Detectives');

insert into book_categories (cat_name, period)
	select cat_name,  ((Random() * 90)+ 35)::int
	from tmp_book_categories;

drop table tmp_book_categories;

insert into book_categories (cat_name, period)
	select 'cat'|| i,  ((Random() * 90)+ 35)::int
	from generate_series(1, 5000) as seq(i);


insert into stocks (adress)
	select 
	case floor(random()*10)
	when 0 then 'Konvalinkova '
	when 1 then 'Snezienkova '
	when 2 then 'Fialkova '
	when 3 then 'Slnecnicova '
	else 'ulica' || floor(random()*i)
	end 
	|| floor(random()*100) || ', Bratislava' as adress
	from generate_series(1, 200) as seq(i);



insert into book_authors (book_id, author_id)
	select id, random_author(id) from books;

insert into book_authors (book_id, author_id)
	select tmp.id, random_author(id) from (select * from books order by random() limit 15) as tmp;



insert into copies (book_id, state, available_distantly, in_library, category, stock_id)
	select id, (random()*30)+70, case when(random() > 0.7) then true else false end, false, random_cat(id), random_stock(id) from books;


insert into copies (book_id, state, available_distantly, in_library, category, stock_id)
    select c.id, (random()*30)+70, case when(random() > 0.7) then true else false end, false, random_cat(id), random_stock(id) 
    from copies c cross join generate_series(1, 40) as seq(i);


insert into readers (first_name, last_name, valid_til)
	select first_name, last_name, timestamp '2021-01-10 20:00:00' + random() * (timestamp '2025-01-20 20:00:00' - timestamp '2021-01-10 10:00:00')
	from tmp_readers;

drop table tmp_readers;

insert into readers (first_name, last_name, valid_til)
select 'janko'||i, 'hrasko'||i, timestamp '2021-01-10 20:00:00' + random() * (timestamp '2025-01-20 20:00:00' - timestamp '2021-01-10 10:00:00')
	from generate_series(1, 1000000) as seq(i);



insert into fees (reader_id, amount, closed, delay)
	select random_reader(i), 
   	 case floor(random()*3)
		when 0 then 5
		when 1 then 10
		when 2 then 15
		end ,
	case floor(random()*2)
		when 0 then false
		when 1 then true
		end ,
	case floor(random()*2)
		when 0 then floor(random()*50)::int+1
		when 1 then null
		end
	from generate_series(1, 10000) as seq(i);
	           
           

insert into reservations (date_from, date_to, reader_id, copy_id, rented)
	select t, t + INTERVAL '3 days', (random()*1000000)::int + 1, random_copy(random()::int), false
	from (select timestamp '2000-01-10 20:00:00' +
	       random() * (timestamp '2021-01-20 20:00:00' -
		           timestamp '2000-01-10 10:00:00') as t from generate_series(1, 1000000) as seq(i)) as tmp2;
		           

insert into rentals (date_from, date_to, returned, reader_id, copy_id )
	select t, t + INTERVAL '90 days' , t + INTERVAL '28 days', (random()*1000000)::int+1, random_copy(random()::int)
	from (select timestamp '2000-01-10 20:00:00' +
	       random() * (timestamp '2021-01-20 20:00:00' -
		           timestamp '2000-01-10 10:00:00') as t from generate_series(1, 1000000) as seq(i)) as tmp2;
		           
		           
		           
		           
